C*****************************************
       program combine segments
C*****************************************
       implicit none
	   
	   integer CD
	   parameter (CD=3000000)
	   real e1, e2, temp, value1, value2, tri, s
	   real tj_1, tj_2
	   real xi1, xf1, yi1, yf1, xi2, xf2, yi2, yf2
	   integer match, i, j, nnline, change, ii, start, trips
	   integer kk, ll, index, header, hash, col_in, col_out
	   integer file_n, first, last, msf, nsf, lsf
	   character*1 one
	   character*1 two
	   character*1 three
	   character*8 keyword
	   character*16 fname
	   character*40 tempword
	   character*16 version
	   character*100 inline
	   character*100 inline2	   
	   
	   dimension e1(3), e2(3), s(21,CD)
	   
       write(6,*) '=============================================='
	   write(6,*) ' PROGRAM COMBINES LISTS OF LINE SEGMENTS'
	   write(6,*) ' AND THE WRITES THEM TO A SINGLE ORDERED LIST  '	 
	   write(6,*) ' IN A FILE ' 
	   write(6,*)
	   write(6,*) ' DEVELOPED BY CMU MRSEC'
	   write(6,*) ' rohrer@cmu.edu'	   
	   write(6,*) ' version 12/01/16'
       write(6,*) '=============================================='

       !compile with gfortran combine_segs.f -O3 -o combine_segs
       !9/9/14: fix issue with 14 column files
       !12/01/16: can handle more than 100 files
       version = 'version 12/01/16'

       !read the input
 5     format(A)
       open(21, file='input.txt', status='old')
       read(21,*) keyword
       read(21,*) first
	   read(21,*) last
       read(21,*) col_in
       read(21,*) col_out
       read(21,5) inline2
       close(21)
       !open the output file
	   open (34, file='all_segments.txt', status='unknown')
        
       do file_n=first,last !This is the main loop over the files

       !Start by opening a file and determining the total number of lines in the data file
         msf=int(file_n/100) !here, the file is opened
         nsf=int((file_n-(msf*100))/10)
         lsf=file_n-(100*msf)-(10*nsf)
         one=char(48+msf)
         two=char(48+nsf)
         three=char(48+lsf)
         fname=keyword//'_'//one//two//three//'.txt'
         open (32, file=fname,status='old')

        !now we count the number of lines in the file
		nnline = 0
 10     continue
		read(32,*,end=11)
		nnline=nnline+1
		goto 10
 11     continue
        close(32)
 12    	format(A,I7,A,I3,A)
		write(6,12) 'There are',nnline,' lines in file',file_n,'.'

        !If there are more lines than allowed in the data structure, stop		
        if (nnline.gt.CD) then 
          write(6,*)'you must increase the size of the s array.  Bye.'
          goto 9020
		endif

        !For the second time, we open the file_n^th file
         msf=int(file_n/100) !here, the file is opened
         nsf=int((file_n-(msf*100))/10)
         lsf=file_n-(100*msf)-(10*nsf)
         one=char(48+msf)
         two=char(48+nsf)
         three=char(48+lsf)
         fname=keyword//'_'//one//two//three//'.txt'
         open (32, file=fname,status='old')

        !Here we determine the number of lines in the Header.
        !Check each line for the string '#'. If found, we know this line is part
        !f the header.  If not, we have reached the data section.
        header = 0
        hash = 0
        do i=1,nnline
	     read(32, "(a)") inline
	     hash = index(inline, '#')
	     if (hash.ne.0) then
	      header=header+1
		  hash=0
		  if (file_n.eq.first) then
		   write(34, "(a)")inline
		  endif
	     else
		 goto 28
	     endif			
	    enddo
 28    continue
       close(32)
       write(6,*)header,' lines in the header'

       !Add some useful information to the header
 81    format(A,A)
       if (file_n.eq.first) then
	    write(34,81)'# comment: ',inline2
	    write(34,81)'# segment file written by combine_segs: ',version
       endif

       !For the third time, we open the file_n^th file
         msf=int(file_n/100) !here, the first file is opened
         nsf=int((file_n-(msf*100))/10)
         lsf=file_n-(100*msf)-(10*nsf)
         one=char(48+msf)
         two=char(48+nsf)
         three=char(48+lsf)
         fname=keyword//'_'//one//two//three//'.txt'
         open (32, file=fname,status='old')
       !this reads the header
       do i=1,header
        read(32, "(a)") inline
       enddo

       !This is where we read the data
       do i=header+1,nnline
         !The section is used when the input file has 21 columns
         if (col_in.eq.21) then
         read(32,*,end=100) s(1,i), s(2,i), s(3,i), s(4,i), s(5,i),
     &	 s(6,i), s(7,i), s(8,i), s(9,i), s(10,i), s(11,i), s(12,i),
     &   s(13,i), s(14,i), s(15,i), s(16,i), s(17,i), s(18,i),
     &   s(19,i), s(20,i), s(21,i)
         endif
         !The section is used when the input file has 14 columns
         if (col_in.eq.14) then
         read(32,*,end=100) s(1,i), s(2,i), s(3,i), s(4,i), s(5,i),
     &	 s(6,i), s(7,i), s(8,i), s(16,i), s(17,i), s(18,i), s(19,i),
     &   s(13,i), s(14,i)
         endif
         !The section is used when the input file has 12 columns
         if (col_in.eq.12) then
		 read(32,*,end=100) s(1,i), s(2,i), s(3,i), s(4,i), s(5,i), 		
     &	 s(6,i), s(7,i), s(8,i), s(16,i), s(17,i), s(18,i), s(19,i)
	     endif
         if (col_in.ne.12.and.col_in.ne.14.and.col_in.ne.21) then
          write(6,*)'col_in must be 12, 14, or 21; good bye.'
          goto 9020
         endif
		enddo

 100    continue		
		close (32)

        !This is where we write out the data in the combined file
 250    format(7f9.3,f8.2,4f11.2)
        do i=header+1,nnline
        if (col_out.eq.12) then
        write(34,250) s(1,i), s(2,i), s(3,i), s(4,i), s(5,i),
     &	 s(6,i), s(14,i), s(15,i), s(16,i), s(17,i), s(18,i), s(19,i)
	    endif
        if (col_out.ne.12) then
         write(6,*)'col_out must be 12; good bye.'
         goto 9020
        endif
        enddo

		enddo ! This is the file_n loop
		
		close(34)
	   
 9020  continue	   
       end