C*****************************************
       program Graph Plane Distribution
C*****************************************
       implicit none
	   include 'common.fi'

       !parameter (CD=9)
       !parameter (CD2=9)
       !dimension gbd(CD,CD,CD,CD2,4*CD2), gbd2(CD2,4*CD2)
	   dimension gbd(36,18,36,9,36), gbd2(9,36)	   
       dimension e1(3), e2(3)
       dimension gg1(3,3), gg2(3,3), dg(3,3)
       dimension so1(3,3), so2(3,3), sa(2), so2t(3,3)
	   dimension ax(3)
	   integer point
	   real interval

       write(6,*) '=============================================='
	   write(6,*) ' PROGRAM TO PRODUCE A STEREOGRAPHIC PROJECTION'
	   write(6,*) ' OF THE DISTRIBUTION OF GRAIN BOUNARY PLANES'
	   write(6,*) ' FOR ALL GRAIN BOUNDARIES'
	   write(6,*)
	   write(6,*) ' THIS VERSION USES THE COMPLETE DOMAIN OF '
	   write(6,*) ' MISORIENTATIONS, FOR USE WITH LOW SYMMETRY  '	   
	   write(6,*) ' CRYSTALS  '
	   write(6,*)	   
       write(6,*) '  version 07/27/2013'
       write(6,*) '  rohrer@cmu.edu'
	   write(6,*) '=============================================='
       
	   version = 'version 07/27/2013'	   
	   
	   degrad = 180./3.14159
       pi = 4.0*atan(1.0)
	   eps = 1.e-6
	   HCD = 90.0

       open(21, file='input.txt', status='old')
	   read(21,*) keyword
       point = index(keyword,'.') - 1	   
	   read(21,*) tempword
       read(21,*) msym
       read(21,*) tempword
       read(21,*) plot_type
	   read(21,*) tempword
       read(21,*) CD, CD2	   
       close (21)
	   
  5    format(A,A)
  6    format(A)
	   write(6,5)'I am graphing data in the file labeled: ', keyword
	   if (plot_type.eq.1) then 
	       write(6,6)'The data will be in the format for gmt'	   
	   endif
	   if (plot_type.eq.2) then 
	       write(6,6)'The data will be in the format for 3D field'	   
	   endif
	   if (plot_type.eq.3) then 
	       write(6,6)'Data will be output in both the gmt and 3D field formats'	   
	   endif
	   if (plot_type.eq.4) then 
	       write(6,6)'Data will be output in the gmt format for plotting in the fundmental zone'		   
	   endif	   
	   if (msym.eq.3) then 
	       write(6,6)'you have specified the symmetry as cubic'	   
	   endif
	   if (msym.eq.2) then 
	       write(6,6)'you have specified the symmetry as hexagonal'	   
	   endif	   
	   if (msym.eq.1) then 
	       write(6,6)'you have specified the symmetry as tetragonal'	   
	   endif	   
	   if (msym.eq.4) then 
	       write(6,6)'you have specified the symmetry as trigonal'	   
	   endif	   
	   write(6,6)'The [001] direction will be normal to the plane of the drawing.'


c  The statement calls the subroutine that contains the symmetry operators.  The variable
c  msym, read from the input file, specifies the symmetry (1 = tetragonal, 2 = hexagonal, 
c  3 = subic, 4 = trigonal), O is a matrix containing the operators, and nsymm is the 
c  number of symmetry operators.  The routine returns O and nsymm.

       call get_symop (msym, O, nsymm)

c  This part is to zero the grain boundary character distribution matrix		
		do i=1,CD*4
	     do j=1,CD*2
	      do k=1,CD*4
	       do ii=1,CD2
	        do jj=1,4*CD2
	         gbd(i,j,k,ii,jj)=0.0
			enddo
	       enddo
		  enddo
	     enddo
	    enddo	

		do ii=1,CD2
		 do jj=1,4*CD2
		  gbd2(ii,jj)=0.0
		 enddo
		enddo

c Check each line for the string '#'. If found, we know this line is part  
c of the header.  If not, we have reached the data section.		
	   open(33, file=keyword, status='old')
       header = 0
       hash = 0
	   do i=1,100  ! max header length is 100 lines
	    read(33, "(a)") inline
	    hash = index(inline, '#')
	    if (hash.ne.0) then
	     header=header+1
		 hash=0
	    else
		 goto 80     
	    endif			
	   enddo
 80   close(33)		


c  the data is read from the file specified in the input file into matrix gbd

	    open (33, file=keyword, status='old')
		do i=1,header
		 read(33, "(a)") inline
		enddo			 
	    do i=1,CD*4
	     do j=1,CD*2
	      do k=1,CD*4
	       do ii=1,CD2
	        do jj=1,4*CD2
	         read (33,*) gbd(i,j,k,ii,jj)
	        enddo
	       enddo
	      enddo
	     enddo
	   enddo
	   close (33)
	   

	    do i=1,CD*4
	     do j=1,CD*2
	      do k=1,CD*4
	       do ii=1,CD2
	        do jj=1,4*CD2
			 !temp=gbd(i,j,k,ii,jj)/(CD*CD*CD)
			 temp=gbd(i,j,k,ii,jj)
	         gbd2(ii,jj)=gbd2(ii,jj)+temp
	        enddo
	       enddo
	      enddo
	     enddo
	   enddo
	   
	   avg=0.0
	   do ii=1,CD2
	    do jj=1,4*CD2
	     avg=avg+gbd2(ii,jj)
	    enddo
	   enddo
	
	   avg=avg/float(4*CD2*CD2)

	   do ii=1,CD2
	    do jj=1,4*CD2
	     gbd2(ii,jj)=gbd2(ii,jj)/avg
	    enddo
	   enddo
	   
	   if (plot_type.eq.2.or.plot_type.eq.3) then
           open (34, file=keyword(1:point)//'_2d.dat'
     &         , status='unknown')
       endif
	   
	   if (plot_type.eq.1.or.plot_type.eq.3) then		
          open (35, file=keyword(1:point)//'_2d_gmt.dat'
     &         ,status='unknown')
		write(35,"(4(1x,f4.1))")  0.0, 0.0, 0.0, 0.0 
		endif
		
       if (plot_type.eq.4) then		
          open (35, file=keyword(1:point)//'_2d_gmt1.gpf'
     &         ,status='unknown')
		write(35,"(4(1x,f4.1))")  0.0, 0.0, 0.0, 0.0 
		endif
		
	   
	   summrd=0.0
	   maxmrd=0.0
	   minmrd=100.0
	   do i_plot=1,31
		do j_plot=1,121
		 theta_plot=3.0*float(i_plot-1)*(pi/180.0)
		  phi_plot=3.0*float(j_plot-1)*(pi/180.0)
		  
c         this call takes angle theta and phi and convert them to a vector, n_plot  

	      call AnglesToV (theta_plot, phi_plot, n_plot)
		  
c         this assigns the normal of interest to n1
		  
	      sum=0.0
	      n1(1)=n_plot(1)
	      n1(2)=n_plot(2)
	      n1(3)=n_plot(3)
		  ct=0
	   
	   
		  do ii_plot=1,nsymm
c           this returns the first symmetry operator		   
		    call symop (O, ii_plot, so1)
c           this rotates n1 by the first, non-transposed operator
		    call MToV (so1, n1, nf)
c           this returns the azimuthal (0 to 90) and in-plane (0 to 360) angles	 
			call VToAngles (nf, sa)
c            these steps find the bin that corresponds to angular parameters		
			 c4=int(float(CD2)*cos(sa(1)))+1
			 c5=int(float(4*CD2)*sa(2)/(pi*2.0))+1
			 if (c4.eq.CD2+1) c4=CD2
			 if (c4.eq.0) c4=1
			 if (c5.eq.4*CD2+1) c5=4*CD2
			
c			 here, we add the value in this bin to a total and increment the
c            counter (ct) so it can be properly averaged later
			
			 sum=sum+gbd2(c4,c5)
			 ct=ct+1
		   enddo
c        this projects the angles for the stereographic projection		 
		 
	     xp=tan(theta_plot*0.5)*cos(phi_plot)
	     yp=tan(theta_plot*0.5)*sin(phi_plot)
		 
c        this line computes the average from all of the indistinuishable bins		 
		 
	     amrd=sum/float(ct)

 750	 format(f8.5,3x,f8.5,3x,f8.3,2(i4))
 
 
c        Write values for ploting in 3D field
 	   if (plot_type.eq.2.or.plot_type.eq.3) then
	     write (34,750) xp, yp, amrd, i_plot, j_plot
		endif 
c        Write values for ploting by GMT		 
	   if (plot_type.eq.1.or.plot_type.eq.3.or.plot_type.eq.4) then
		 write (35,*) phi_plot*degrad, (90.-(theta_plot*degrad)), amrd
		endif
		 summrd=summrd+amrd
		 if (maxmrd.lt.amrd) maxmrd=amrd
		 if (minmrd.gt.amrd) minmrd=amrd
		 

		 enddo
	   enddo
	   
 760   format(A,f5.2,A)	
 770   format(A,f7.2,A)    
	   write(6,760) 'The average value is ',summrd/3751,' MRD.'
	   write(6,770) 'The minimum value is ',minmrd,' MRD.'
	   write(6,770) 'The maximum value is ',maxmrd,' MRD.'
       interval=(maxmrd-minmrd)/10
	   
       if (plot_type.eq.2.or.plot_type.eq.3) then	
	   close(34)
	   endif
	   
	   if (plot_type.eq.1.or.plot_type.eq.3.or.plot_type.eq.4) then
	   close(35)
	   endif
	   

		

  780  format(A,A,A,f4.2,1x,f4.2,1x,f4.2)	   
	   if (plot_type.eq.1.or.plot_type.eq.3) then 
	       write(6,*) ' '
	       write(6,6)'to initiate the gmt script, enter ./Draw_stereograms 1 [filename]_2d_gmt 2d rainbow [min] [max] [interval]'
		   write(6,780)'For example: ./Draw_stereograms 1 ',keyword(1:point),'_2d_gmt 2d rainbow ',minmrd,maxmrd,interval
	   endif
  781  format(A,A,A,f4.2,1x,f4.2,1x,f4.2,A)	
	   if (plot_type.eq.4) then 
	       write(6,*) ' '
	       write(6,6)'to initiate the gmt script, enter ./Draw_stereograms 1 [filename]_2d_gmt IF rainbow [min] [max] [interval] stereo CUBIC'
		   write(6,781)'For example: ./Draw_stereograms 1 ',keyword(1:point),'_2d_gmt IF rainbow ',minmrd,maxmrd,interval,' stereo CUBIC'
	   endif

       continue	   
       end
